/* Process.c generated by valac 0.56.14, the Vala compiler
 * generated from Process.vala, do not modify */

/* Process.vala
 *
 * Copyright 2019 Hannes Schulze
 *
 * Simplified version of Process.vala by stsdc published under
 * the GPL-3.0 license:
 * https://github.com/stsdc/monitor/blob/master/src/Managers/Process.vala
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <signal.h>
#include <sys/types.h>
#include <gio/gio.h>
#include <stdio.h>
#include <glibtop/procuid.h>
#include <glibtop.h>
#include <glibtop/proctime.h>
#include <glibtop/procmem.h>
#include <gdk/gdk.h>
#include <gdk/gdkx.h>
#include <libwnck/libwnck.h>
#include <unistd.h>
#include <glibtop/procstate.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define OPTIMIZER_UTILS_TYPE_PROCESS (optimizer_utils_process_get_type ())
#define OPTIMIZER_UTILS_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), OPTIMIZER_UTILS_TYPE_PROCESS, OptimizerUtilsProcess))
#define OPTIMIZER_UTILS_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), OPTIMIZER_UTILS_TYPE_PROCESS, OptimizerUtilsProcessClass))
#define OPTIMIZER_UTILS_IS_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), OPTIMIZER_UTILS_TYPE_PROCESS))
#define OPTIMIZER_UTILS_IS_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), OPTIMIZER_UTILS_TYPE_PROCESS))
#define OPTIMIZER_UTILS_PROCESS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), OPTIMIZER_UTILS_TYPE_PROCESS, OptimizerUtilsProcessClass))

typedef struct _OptimizerUtilsProcess OptimizerUtilsProcess;
typedef struct _OptimizerUtilsProcessClass OptimizerUtilsProcessClass;
typedef struct _OptimizerUtilsProcessPrivate OptimizerUtilsProcessPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _OptimizerUtilsParamSpecProcess OptimizerUtilsParamSpecProcess;

struct _OptimizerUtilsProcess {
	GTypeInstance parent_instance;
	volatile int ref_count;
	OptimizerUtilsProcessPrivate * priv;
};

struct _OptimizerUtilsProcessClass {
	GTypeClass parent_class;
	void (*finalize) (OptimizerUtilsProcess *self);
};

struct _OptimizerUtilsProcessPrivate {
	gboolean _exists;
	gint _pid;
	gint _pgrp;
	gchar* _command;
	gchar* _user;
	gdouble _cpu_usage;
	guint64 cpu_last_used;
	guint64 _mem_usage;
	guint64 last_total;
};

struct _OptimizerUtilsParamSpecProcess {
	GParamSpec parent_instance;
};

static gint OptimizerUtilsProcess_private_offset;
static gpointer optimizer_utils_process_parent_class = NULL;

VALA_EXTERN gpointer optimizer_utils_process_ref (gpointer instance);
VALA_EXTERN void optimizer_utils_process_unref (gpointer instance);
VALA_EXTERN GParamSpec* optimizer_utils_param_spec_process (const gchar* name,
                                                const gchar* nick,
                                                const gchar* blurb,
                                                GType object_type,
                                                GParamFlags flags);
VALA_EXTERN void optimizer_utils_value_set_process (GValue* value,
                                        gpointer v_object);
VALA_EXTERN void optimizer_utils_value_take_process (GValue* value,
                                         gpointer v_object);
VALA_EXTERN gpointer optimizer_utils_value_get_process (const GValue* value);
VALA_EXTERN GType optimizer_utils_process_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (OptimizerUtilsProcess, optimizer_utils_process_unref)
VALA_EXTERN OptimizerUtilsProcess* optimizer_utils_process_new (gint _pid);
VALA_EXTERN OptimizerUtilsProcess* optimizer_utils_process_construct (GType object_type,
                                                          gint _pid);
static void optimizer_utils_process_set_pid (OptimizerUtilsProcess* self,
                                      gint value);
static gboolean optimizer_utils_process_read_stat (OptimizerUtilsProcess* self,
                                            guint64 cpu_total,
                                            guint64 cpu_last_total);
static gboolean optimizer_utils_process_read_cmdline (OptimizerUtilsProcess* self);
static void optimizer_utils_process_set_exists (OptimizerUtilsProcess* self,
                                         gboolean value);
VALA_EXTERN gboolean optimizer_utils_process_update (OptimizerUtilsProcess* self,
                                         guint64 cpu_total,
                                         guint64 cpu_last_total);
VALA_EXTERN gboolean optimizer_utils_process_get_exists (OptimizerUtilsProcess* self);
VALA_EXTERN gboolean optimizer_utils_process_kill (OptimizerUtilsProcess* self);
VALA_EXTERN gint optimizer_utils_process_get_pid (OptimizerUtilsProcess* self);
static void optimizer_utils_process_set_pgrp (OptimizerUtilsProcess* self,
                                       gint value);
static void optimizer_utils_process_set_cpu_usage (OptimizerUtilsProcess* self,
                                            gdouble value);
static void optimizer_utils_process_set_mem_usage (OptimizerUtilsProcess* self,
                                            guint64 value);
VALA_EXTERN guint64 optimizer_utils_process_get_mem_usage (OptimizerUtilsProcess* self);
static void optimizer_utils_process_set_user (OptimizerUtilsProcess* self,
                                       const gchar* value);
static void optimizer_utils_process_set_command (OptimizerUtilsProcess* self,
                                          const gchar* value);
VALA_EXTERN gint optimizer_utils_process_get_pgrp (OptimizerUtilsProcess* self);
VALA_EXTERN const gchar* optimizer_utils_process_get_command (OptimizerUtilsProcess* self);
VALA_EXTERN const gchar* optimizer_utils_process_get_user (OptimizerUtilsProcess* self);
VALA_EXTERN gdouble optimizer_utils_process_get_cpu_usage (OptimizerUtilsProcess* self);
static void optimizer_utils_process_finalize (OptimizerUtilsProcess * obj);
static GType optimizer_utils_process_get_type_once (void);

static inline gpointer
optimizer_utils_process_get_instance_private (OptimizerUtilsProcess* self)
{
	return G_STRUCT_MEMBER_P (self, OptimizerUtilsProcess_private_offset);
}

OptimizerUtilsProcess*
optimizer_utils_process_construct (GType object_type,
                                   gint _pid)
{
	OptimizerUtilsProcess* self = NULL;
	gboolean _tmp0_ = FALSE;
#line 63 "../src/utils/Process.vala"
	self = (OptimizerUtilsProcess*) g_type_create_instance (object_type);
#line 64 "../src/utils/Process.vala"
	optimizer_utils_process_set_pid (self, _pid);
#line 65 "../src/utils/Process.vala"
	self->priv->last_total = (guint64) 0;
#line 67 "../src/utils/Process.vala"
	if (optimizer_utils_process_read_stat (self, (guint64) 0, (guint64) 1)) {
#line 67 "../src/utils/Process.vala"
		_tmp0_ = optimizer_utils_process_read_cmdline (self);
#line 174 "Process.c"
	} else {
#line 67 "../src/utils/Process.vala"
		_tmp0_ = FALSE;
#line 178 "Process.c"
	}
#line 67 "../src/utils/Process.vala"
	optimizer_utils_process_set_exists (self, _tmp0_);
#line 63 "../src/utils/Process.vala"
	return self;
#line 184 "Process.c"
}

OptimizerUtilsProcess*
optimizer_utils_process_new (gint _pid)
{
#line 63 "../src/utils/Process.vala"
	return optimizer_utils_process_construct (OPTIMIZER_UTILS_TYPE_PROCESS, _pid);
#line 192 "Process.c"
}

gboolean
optimizer_utils_process_update (OptimizerUtilsProcess* self,
                                guint64 cpu_total,
                                guint64 cpu_last_total)
{
	gboolean _tmp0_;
	gboolean result;
#line 72 "../src/utils/Process.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 73 "../src/utils/Process.vala"
	optimizer_utils_process_set_exists (self, optimizer_utils_process_read_stat (self, cpu_total, cpu_last_total));
#line 75 "../src/utils/Process.vala"
	_tmp0_ = self->priv->_exists;
#line 75 "../src/utils/Process.vala"
	result = _tmp0_;
#line 75 "../src/utils/Process.vala"
	return result;
#line 212 "Process.c"
}

gboolean
optimizer_utils_process_kill (OptimizerUtilsProcess* self)
{
	gint _tmp0_;
	gboolean result;
#line 80 "../src/utils/Process.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 81 "../src/utils/Process.vala"
	_tmp0_ = self->priv->_pid;
#line 81 "../src/utils/Process.vala"
	if (kill ((pid_t) _tmp0_, (gint) SIGINT) == 0) {
#line 82 "../src/utils/Process.vala"
		result = TRUE;
#line 82 "../src/utils/Process.vala"
		return result;
#line 230 "Process.c"
	}
#line 84 "../src/utils/Process.vala"
	result = FALSE;
#line 84 "../src/utils/Process.vala"
	return result;
#line 236 "Process.c"
}

static gboolean
optimizer_utils_process_read_stat (OptimizerUtilsProcess* self,
                                   guint64 cpu_total,
                                   guint64 cpu_last_total)
{
	GFile* stat_file = NULL;
	gint _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 88 "../src/utils/Process.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 90 "../src/utils/Process.vala"
	_tmp0_ = self->priv->_pid;
#line 90 "../src/utils/Process.vala"
	_tmp1_ = g_strdup_printf ("/proc/%d/stat", _tmp0_);
#line 90 "../src/utils/Process.vala"
	_tmp2_ = _tmp1_;
#line 90 "../src/utils/Process.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 90 "../src/utils/Process.vala"
	_tmp4_ = _tmp3_;
#line 90 "../src/utils/Process.vala"
	_g_free0 (_tmp2_);
#line 90 "../src/utils/Process.vala"
	stat_file = _tmp4_;
#line 93 "../src/utils/Process.vala"
	_tmp5_ = stat_file;
#line 93 "../src/utils/Process.vala"
	if (!g_file_query_exists (_tmp5_, NULL)) {
#line 94 "../src/utils/Process.vala"
		result = FALSE;
#line 94 "../src/utils/Process.vala"
		_g_object_unref0 (stat_file);
#line 94 "../src/utils/Process.vala"
		return result;
#line 279 "Process.c"
	}
	{
		GFileInputStream* _tmp6_ = NULL;
		GFile* _tmp7_;
		GFileInputStream* _tmp8_;
		GDataInputStream* dis = NULL;
		GDataInputStream* _tmp9_;
		gchar* stat_contents = NULL;
		GDataInputStream* _tmp10_;
		gchar* _tmp11_;
		const gchar* _tmp12_;
		glibtop_proc_uid uid = {0};
		gint _tmp17_;
		glibtop_proc_uid _tmp18_ = {0};
		glibtop_proc_uid _tmp19_;
		glibtop_proc_time proc_time = {0};
		gint _tmp20_;
		glibtop_proc_time _tmp21_ = {0};
		glibtop_proc_time _tmp22_;
		glibtop_proc_time _tmp23_;
		glibtop_proc_mem proc_mem = {0};
		gint _tmp24_;
		glibtop_proc_mem _tmp25_ = {0};
		glibtop_proc_mem _tmp26_;
		glibtop_proc_mem _tmp27_;
		GdkDisplay* _tmp28_;
		const gchar* _tmp34_;
#line 99 "../src/utils/Process.vala"
		_tmp7_ = stat_file;
#line 99 "../src/utils/Process.vala"
		_tmp8_ = g_file_read (_tmp7_, NULL, &_inner_error0_);
#line 99 "../src/utils/Process.vala"
		_tmp6_ = _tmp8_;
#line 99 "../src/utils/Process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 315 "Process.c"
			goto __catch0_g_error;
		}
#line 99 "../src/utils/Process.vala"
		_tmp9_ = g_data_input_stream_new ((GInputStream*) _tmp6_);
#line 99 "../src/utils/Process.vala"
		dis = _tmp9_;
#line 100 "../src/utils/Process.vala"
		_tmp10_ = dis;
#line 100 "../src/utils/Process.vala"
		_tmp11_ = g_data_input_stream_read_line (_tmp10_, NULL, NULL, &_inner_error0_);
#line 100 "../src/utils/Process.vala"
		stat_contents = _tmp11_;
#line 100 "../src/utils/Process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 100 "../src/utils/Process.vala"
			_g_object_unref0 (dis);
#line 100 "../src/utils/Process.vala"
			_g_object_unref0 (_tmp6_);
#line 334 "Process.c"
			goto __catch0_g_error;
		}
#line 102 "../src/utils/Process.vala"
		_tmp12_ = stat_contents;
#line 102 "../src/utils/Process.vala"
		if (_tmp12_ == NULL) {
#line 341 "Process.c"
			FILE* _tmp13_;
			GFile* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
#line 103 "../src/utils/Process.vala"
			_tmp13_ = stderr;
#line 103 "../src/utils/Process.vala"
			_tmp14_ = stat_file;
#line 103 "../src/utils/Process.vala"
			_tmp15_ = g_file_get_path (_tmp14_);
#line 103 "../src/utils/Process.vala"
			_tmp16_ = _tmp15_;
#line 103 "../src/utils/Process.vala"
			fprintf (_tmp13_, "Error reading stat file '%s': couldn't read_line ()\n", _tmp16_);
#line 103 "../src/utils/Process.vala"
			_g_free0 (_tmp16_);
#line 104 "../src/utils/Process.vala"
			result = FALSE;
#line 104 "../src/utils/Process.vala"
			_g_free0 (stat_contents);
#line 104 "../src/utils/Process.vala"
			_g_object_unref0 (dis);
#line 104 "../src/utils/Process.vala"
			_g_object_unref0 (_tmp6_);
#line 104 "../src/utils/Process.vala"
			_g_object_unref0 (stat_file);
#line 104 "../src/utils/Process.vala"
			return result;
#line 370 "Process.c"
		}
#line 109 "../src/utils/Process.vala"
		_tmp17_ = self->priv->_pid;
#line 109 "../src/utils/Process.vala"
		glibtop_get_proc_uid (&_tmp18_, _tmp17_);
#line 109 "../src/utils/Process.vala"
		uid = _tmp18_;
#line 110 "../src/utils/Process.vala"
		_tmp19_ = uid;
#line 110 "../src/utils/Process.vala"
		optimizer_utils_process_set_pgrp (self, (gint) _tmp19_.pgrp);
#line 114 "../src/utils/Process.vala"
		_tmp20_ = self->priv->_pid;
#line 114 "../src/utils/Process.vala"
		glibtop_get_proc_time (&_tmp21_, _tmp20_);
#line 114 "../src/utils/Process.vala"
		proc_time = _tmp21_;
#line 115 "../src/utils/Process.vala"
		_tmp22_ = proc_time;
#line 115 "../src/utils/Process.vala"
		optimizer_utils_process_set_cpu_usage (self, ((gdouble) (_tmp22_.rtime - self->priv->cpu_last_used)) / (cpu_total - cpu_last_total));
#line 116 "../src/utils/Process.vala"
		_tmp23_ = proc_time;
#line 116 "../src/utils/Process.vala"
		self->priv->cpu_last_used = _tmp23_.rtime;
#line 120 "../src/utils/Process.vala"
		_tmp24_ = self->priv->_pid;
#line 120 "../src/utils/Process.vala"
		glibtop_get_proc_mem (&_tmp25_, _tmp24_);
#line 120 "../src/utils/Process.vala"
		proc_mem = _tmp25_;
#line 121 "../src/utils/Process.vala"
		_tmp26_ = proc_mem;
#line 121 "../src/utils/Process.vala"
		_tmp27_ = proc_mem;
#line 121 "../src/utils/Process.vala"
		optimizer_utils_process_set_mem_usage (self, _tmp26_.resident - _tmp27_.share);
#line 123 "../src/utils/Process.vala"
		_tmp28_ = gdk_display_get_default ();
#line 123 "../src/utils/Process.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp28_, gdk_x11_display_get_type ())) {
#line 412 "Process.c"
			WnckResourceUsage resu = {0};
			GdkDisplay* _tmp29_;
			gint _tmp30_;
			WnckResourceUsage _tmp31_ = {0};
			guint64 _tmp32_;
			WnckResourceUsage _tmp33_;
#line 124 "../src/utils/Process.vala"
			_tmp29_ = gdk_display_get_default ();
#line 124 "../src/utils/Process.vala"
			_tmp30_ = self->priv->_pid;
#line 124 "../src/utils/Process.vala"
			wnck_pid_read_resource_usage (_tmp29_, (gulong) _tmp30_, &_tmp31_);
#line 124 "../src/utils/Process.vala"
			resu = _tmp31_;
#line 125 "../src/utils/Process.vala"
			_tmp32_ = self->priv->_mem_usage;
#line 125 "../src/utils/Process.vala"
			_tmp33_ = resu;
#line 125 "../src/utils/Process.vala"
			optimizer_utils_process_set_mem_usage (self, _tmp32_ + _tmp33_.total_bytes_estimate);
#line 433 "Process.c"
		}
#line 129 "../src/utils/Process.vala"
		_tmp34_ = getlogin ();
#line 129 "../src/utils/Process.vala"
		optimizer_utils_process_set_user (self, _tmp34_);
#line 97 "../src/utils/Process.vala"
		_g_free0 (stat_contents);
#line 97 "../src/utils/Process.vala"
		_g_object_unref0 (dis);
#line 97 "../src/utils/Process.vala"
		_g_object_unref0 (_tmp6_);
#line 445 "Process.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp35_;
		const gchar* _tmp36_;
#line 97 "../src/utils/Process.vala"
		e = _inner_error0_;
#line 97 "../src/utils/Process.vala"
		_inner_error0_ = NULL;
#line 131 "../src/utils/Process.vala"
		_tmp35_ = e;
#line 131 "../src/utils/Process.vala"
		_tmp36_ = _tmp35_->message;
#line 131 "../src/utils/Process.vala"
		g_warning ("Process.vala:131: Can't read process stat: '%s'", _tmp36_);
#line 132 "../src/utils/Process.vala"
		result = FALSE;
#line 132 "../src/utils/Process.vala"
		_g_error_free0 (e);
#line 132 "../src/utils/Process.vala"
		_g_object_unref0 (stat_file);
#line 132 "../src/utils/Process.vala"
		return result;
#line 471 "Process.c"
	}
	__finally0:
#line 97 "../src/utils/Process.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 476 "Process.c"
		gboolean _tmp37_ = FALSE;
#line 97 "../src/utils/Process.vala"
		_g_object_unref0 (stat_file);
#line 97 "../src/utils/Process.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 97 "../src/utils/Process.vala"
		g_clear_error (&_inner_error0_);
#line 97 "../src/utils/Process.vala"
		return _tmp37_;
#line 486 "Process.c"
	}
#line 135 "../src/utils/Process.vala"
	result = TRUE;
#line 135 "../src/utils/Process.vala"
	_g_object_unref0 (stat_file);
#line 135 "../src/utils/Process.vala"
	return result;
#line 494 "Process.c"
}

/**
         * Reads the /proc/%pid%/cmdline file and updates from the information contained therein.
         */
static gboolean
optimizer_utils_process_read_cmdline (OptimizerUtilsProcess* self)
{
	GFile* cmdline_file = NULL;
	gint _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 141 "../src/utils/Process.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 143 "../src/utils/Process.vala"
	_tmp0_ = self->priv->_pid;
#line 143 "../src/utils/Process.vala"
	_tmp1_ = g_strdup_printf ("/proc/%d/cmdline", _tmp0_);
#line 143 "../src/utils/Process.vala"
	_tmp2_ = _tmp1_;
#line 143 "../src/utils/Process.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 143 "../src/utils/Process.vala"
	_tmp4_ = _tmp3_;
#line 143 "../src/utils/Process.vala"
	_g_free0 (_tmp2_);
#line 143 "../src/utils/Process.vala"
	cmdline_file = _tmp4_;
#line 146 "../src/utils/Process.vala"
	_tmp5_ = cmdline_file;
#line 146 "../src/utils/Process.vala"
	if (!g_file_query_exists (_tmp5_, NULL)) {
#line 532 "Process.c"
		GFile* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 147 "../src/utils/Process.vala"
		_tmp6_ = cmdline_file;
#line 147 "../src/utils/Process.vala"
		_tmp7_ = g_file_get_path (_tmp6_);
#line 147 "../src/utils/Process.vala"
		_tmp8_ = _tmp7_;
#line 147 "../src/utils/Process.vala"
		g_warning ("Process.vala:147: File '%s' doesn't exist.\n", _tmp8_);
#line 147 "../src/utils/Process.vala"
		_g_free0 (_tmp8_);
#line 148 "../src/utils/Process.vala"
		result = FALSE;
#line 148 "../src/utils/Process.vala"
		_g_object_unref0 (cmdline_file);
#line 148 "../src/utils/Process.vala"
		return result;
#line 552 "Process.c"
	}
	{
		GFileInputStream* _tmp9_ = NULL;
		GFile* _tmp10_;
		GFileInputStream* _tmp11_;
		GDataInputStream* dis = NULL;
		GDataInputStream* _tmp12_;
		guint8* cmdline_contents_array = NULL;
		guint8* _tmp13_;
		gint cmdline_contents_array_length1;
		gint _cmdline_contents_array_size_;
		gssize size = 0L;
		GDataInputStream* _tmp14_;
		guint8* _tmp15_;
		gint _tmp15__length1;
		guint8* _tmp24_;
		gint _tmp24__length1;
		gchar* cmdline_contents = NULL;
		guint8* _tmp25_;
		gint _tmp25__length1;
		gchar* _tmp26_;
		glibtop_proc_state proc_state = {0};
		gint _tmp27_;
		glibtop_proc_state _tmp28_ = {0};
		const gchar* _tmp29_;
#line 152 "../src/utils/Process.vala"
		_tmp10_ = cmdline_file;
#line 152 "../src/utils/Process.vala"
		_tmp11_ = g_file_read (_tmp10_, NULL, &_inner_error0_);
#line 152 "../src/utils/Process.vala"
		_tmp9_ = _tmp11_;
#line 152 "../src/utils/Process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 586 "Process.c"
			goto __catch0_g_error;
		}
#line 152 "../src/utils/Process.vala"
		_tmp12_ = g_data_input_stream_new ((GInputStream*) _tmp9_);
#line 152 "../src/utils/Process.vala"
		dis = _tmp12_;
#line 153 "../src/utils/Process.vala"
		_tmp13_ = g_new0 (guint8, 4097);
#line 153 "../src/utils/Process.vala"
		cmdline_contents_array = _tmp13_;
#line 153 "../src/utils/Process.vala"
		cmdline_contents_array_length1 = 4097;
#line 153 "../src/utils/Process.vala"
		_cmdline_contents_array_size_ = cmdline_contents_array_length1;
#line 154 "../src/utils/Process.vala"
		_tmp14_ = dis;
#line 154 "../src/utils/Process.vala"
		_tmp15_ = cmdline_contents_array;
#line 154 "../src/utils/Process.vala"
		_tmp15__length1 = cmdline_contents_array_length1;
#line 154 "../src/utils/Process.vala"
		size = g_input_stream_read ((GInputStream*) _tmp14_, _tmp15_, (gsize) _tmp15__length1, NULL, &_inner_error0_);
#line 154 "../src/utils/Process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 154 "../src/utils/Process.vala"
			cmdline_contents_array = (g_free (cmdline_contents_array), NULL);
#line 154 "../src/utils/Process.vala"
			_g_object_unref0 (dis);
#line 154 "../src/utils/Process.vala"
			_g_object_unref0 (_tmp9_);
#line 617 "Process.c"
			goto __catch0_g_error;
		}
#line 156 "../src/utils/Process.vala"
		if (size <= ((gssize) 0)) {
#line 158 "../src/utils/Process.vala"
			result = TRUE;
#line 158 "../src/utils/Process.vala"
			cmdline_contents_array = (g_free (cmdline_contents_array), NULL);
#line 158 "../src/utils/Process.vala"
			_g_object_unref0 (dis);
#line 158 "../src/utils/Process.vala"
			_g_object_unref0 (_tmp9_);
#line 158 "../src/utils/Process.vala"
			_g_object_unref0 (cmdline_file);
#line 158 "../src/utils/Process.vala"
			return result;
#line 634 "Process.c"
		}
		{
			gint pos = 0;
#line 163 "../src/utils/Process.vala"
			pos = 0;
#line 640 "Process.c"
			{
				gboolean _tmp16_ = FALSE;
#line 163 "../src/utils/Process.vala"
				_tmp16_ = TRUE;
#line 163 "../src/utils/Process.vala"
				while (TRUE) {
#line 647 "Process.c"
					gboolean _tmp18_ = FALSE;
					guint8* _tmp19_;
					gint _tmp19__length1;
					guint8 _tmp20_;
#line 163 "../src/utils/Process.vala"
					if (!_tmp16_) {
#line 654 "Process.c"
						gint _tmp17_;
#line 163 "../src/utils/Process.vala"
						_tmp17_ = pos;
#line 163 "../src/utils/Process.vala"
						pos = _tmp17_ + 1;
#line 660 "Process.c"
					}
#line 163 "../src/utils/Process.vala"
					_tmp16_ = FALSE;
#line 163 "../src/utils/Process.vala"
					if (!(((gssize) pos) < size)) {
#line 163 "../src/utils/Process.vala"
						break;
#line 668 "Process.c"
					}
#line 164 "../src/utils/Process.vala"
					_tmp19_ = cmdline_contents_array;
#line 164 "../src/utils/Process.vala"
					_tmp19__length1 = cmdline_contents_array_length1;
#line 164 "../src/utils/Process.vala"
					_tmp20_ = _tmp19_[pos];
#line 164 "../src/utils/Process.vala"
					if (_tmp20_ == ((guint8) '\0')) {
#line 164 "../src/utils/Process.vala"
						_tmp18_ = TRUE;
#line 680 "Process.c"
					} else {
						guint8* _tmp21_;
						gint _tmp21__length1;
						guint8 _tmp22_;
#line 164 "../src/utils/Process.vala"
						_tmp21_ = cmdline_contents_array;
#line 164 "../src/utils/Process.vala"
						_tmp21__length1 = cmdline_contents_array_length1;
#line 164 "../src/utils/Process.vala"
						_tmp22_ = _tmp21_[pos];
#line 164 "../src/utils/Process.vala"
						_tmp18_ = _tmp22_ == ((guint8) '\n');
#line 693 "Process.c"
					}
#line 164 "../src/utils/Process.vala"
					if (_tmp18_) {
#line 697 "Process.c"
						guint8* _tmp23_;
						gint _tmp23__length1;
#line 165 "../src/utils/Process.vala"
						_tmp23_ = cmdline_contents_array;
#line 165 "../src/utils/Process.vala"
						_tmp23__length1 = cmdline_contents_array_length1;
#line 165 "../src/utils/Process.vala"
						_tmp23_[pos] = (guint8) ' ';
#line 706 "Process.c"
					}
				}
			}
		}
#line 168 "../src/utils/Process.vala"
		_tmp24_ = cmdline_contents_array;
#line 168 "../src/utils/Process.vala"
		_tmp24__length1 = cmdline_contents_array_length1;
#line 168 "../src/utils/Process.vala"
		_tmp24_[size] = (guint8) '\0';
#line 169 "../src/utils/Process.vala"
		_tmp25_ = cmdline_contents_array;
#line 169 "../src/utils/Process.vala"
		_tmp25__length1 = cmdline_contents_array_length1;
#line 169 "../src/utils/Process.vala"
		_tmp26_ = g_strdup ((const gchar*) _tmp25_);
#line 169 "../src/utils/Process.vala"
		cmdline_contents = _tmp26_;
#line 173 "../src/utils/Process.vala"
		_tmp27_ = self->priv->_pid;
#line 173 "../src/utils/Process.vala"
		glibtop_get_proc_state (&_tmp28_, _tmp27_);
#line 173 "../src/utils/Process.vala"
		proc_state = _tmp28_;
#line 175 "../src/utils/Process.vala"
		_tmp29_ = cmdline_contents;
#line 175 "../src/utils/Process.vala"
		optimizer_utils_process_set_command (self, _tmp29_);
#line 150 "../src/utils/Process.vala"
		_g_free0 (cmdline_contents);
#line 150 "../src/utils/Process.vala"
		cmdline_contents_array = (g_free (cmdline_contents_array), NULL);
#line 150 "../src/utils/Process.vala"
		_g_object_unref0 (dis);
#line 150 "../src/utils/Process.vala"
		_g_object_unref0 (_tmp9_);
#line 743 "Process.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp30_;
		GFile* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		GError* _tmp34_;
		const gchar* _tmp35_;
#line 150 "../src/utils/Process.vala"
		e = _inner_error0_;
#line 150 "../src/utils/Process.vala"
		_inner_error0_ = NULL;
#line 178 "../src/utils/Process.vala"
		_tmp30_ = stderr;
#line 178 "../src/utils/Process.vala"
		_tmp31_ = cmdline_file;
#line 178 "../src/utils/Process.vala"
		_tmp32_ = g_file_get_path (_tmp31_);
#line 178 "../src/utils/Process.vala"
		_tmp33_ = _tmp32_;
#line 178 "../src/utils/Process.vala"
		_tmp34_ = e;
#line 178 "../src/utils/Process.vala"
		_tmp35_ = _tmp34_->message;
#line 178 "../src/utils/Process.vala"
		fprintf (_tmp30_, "Error reading cmdline file '%s': %s\n", _tmp33_, _tmp35_);
#line 178 "../src/utils/Process.vala"
		_g_free0 (_tmp33_);
#line 179 "../src/utils/Process.vala"
		result = FALSE;
#line 179 "../src/utils/Process.vala"
		_g_error_free0 (e);
#line 179 "../src/utils/Process.vala"
		_g_object_unref0 (cmdline_file);
#line 179 "../src/utils/Process.vala"
		return result;
#line 783 "Process.c"
	}
	__finally0:
#line 150 "../src/utils/Process.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 788 "Process.c"
		gboolean _tmp36_ = FALSE;
#line 150 "../src/utils/Process.vala"
		_g_object_unref0 (cmdline_file);
#line 150 "../src/utils/Process.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 150 "../src/utils/Process.vala"
		g_clear_error (&_inner_error0_);
#line 150 "../src/utils/Process.vala"
		return _tmp36_;
#line 798 "Process.c"
	}
#line 182 "../src/utils/Process.vala"
	result = TRUE;
#line 182 "../src/utils/Process.vala"
	_g_object_unref0 (cmdline_file);
#line 182 "../src/utils/Process.vala"
	return result;
#line 806 "Process.c"
}

gboolean
optimizer_utils_process_get_exists (OptimizerUtilsProcess* self)
{
	gboolean result;
#line 32 "../src/utils/Process.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 32 "../src/utils/Process.vala"
	result = self->priv->_exists;
#line 32 "../src/utils/Process.vala"
	return result;
#line 819 "Process.c"
}

static void
optimizer_utils_process_set_exists (OptimizerUtilsProcess* self,
                                    gboolean value)
{
#line 32 "../src/utils/Process.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/utils/Process.vala"
	self->priv->_exists = value;
#line 830 "Process.c"
}

gint
optimizer_utils_process_get_pid (OptimizerUtilsProcess* self)
{
	gint result;
#line 35 "../src/utils/Process.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 35 "../src/utils/Process.vala"
	result = self->priv->_pid;
#line 35 "../src/utils/Process.vala"
	return result;
#line 843 "Process.c"
}

static void
optimizer_utils_process_set_pid (OptimizerUtilsProcess* self,
                                 gint value)
{
#line 35 "../src/utils/Process.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/utils/Process.vala"
	self->priv->_pid = value;
#line 854 "Process.c"
}

gint
optimizer_utils_process_get_pgrp (OptimizerUtilsProcess* self)
{
	gint result;
#line 38 "../src/utils/Process.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 38 "../src/utils/Process.vala"
	result = self->priv->_pgrp;
#line 38 "../src/utils/Process.vala"
	return result;
#line 867 "Process.c"
}

static void
optimizer_utils_process_set_pgrp (OptimizerUtilsProcess* self,
                                  gint value)
{
#line 38 "../src/utils/Process.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/utils/Process.vala"
	self->priv->_pgrp = value;
#line 878 "Process.c"
}

const gchar*
optimizer_utils_process_get_command (OptimizerUtilsProcess* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 41 "../src/utils/Process.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 41 "../src/utils/Process.vala"
	_tmp0_ = self->priv->_command;
#line 41 "../src/utils/Process.vala"
	result = _tmp0_;
#line 41 "../src/utils/Process.vala"
	return result;
#line 894 "Process.c"
}

static void
optimizer_utils_process_set_command (OptimizerUtilsProcess* self,
                                     const gchar* value)
{
	gchar* _tmp0_;
#line 41 "../src/utils/Process.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/utils/Process.vala"
	_tmp0_ = g_strdup (value);
#line 41 "../src/utils/Process.vala"
	_g_free0 (self->priv->_command);
#line 41 "../src/utils/Process.vala"
	self->priv->_command = _tmp0_;
#line 910 "Process.c"
}

const gchar*
optimizer_utils_process_get_user (OptimizerUtilsProcess* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 44 "../src/utils/Process.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 44 "../src/utils/Process.vala"
	_tmp0_ = self->priv->_user;
#line 44 "../src/utils/Process.vala"
	result = _tmp0_;
#line 44 "../src/utils/Process.vala"
	return result;
#line 926 "Process.c"
}

static void
optimizer_utils_process_set_user (OptimizerUtilsProcess* self,
                                  const gchar* value)
{
	gchar* _tmp0_;
#line 44 "../src/utils/Process.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/utils/Process.vala"
	_tmp0_ = g_strdup (value);
#line 44 "../src/utils/Process.vala"
	_g_free0 (self->priv->_user);
#line 44 "../src/utils/Process.vala"
	self->priv->_user = _tmp0_;
#line 942 "Process.c"
}

gdouble
optimizer_utils_process_get_cpu_usage (OptimizerUtilsProcess* self)
{
	gdouble result;
#line 51 "../src/utils/Process.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 51 "../src/utils/Process.vala"
	result = self->priv->_cpu_usage;
#line 51 "../src/utils/Process.vala"
	return result;
#line 955 "Process.c"
}

static void
optimizer_utils_process_set_cpu_usage (OptimizerUtilsProcess* self,
                                       gdouble value)
{
#line 51 "../src/utils/Process.vala"
	g_return_if_fail (self != NULL);
#line 51 "../src/utils/Process.vala"
	self->priv->_cpu_usage = value;
#line 966 "Process.c"
}

guint64
optimizer_utils_process_get_mem_usage (OptimizerUtilsProcess* self)
{
	guint64 result;
#line 57 "../src/utils/Process.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 57 "../src/utils/Process.vala"
	result = self->priv->_mem_usage;
#line 57 "../src/utils/Process.vala"
	return result;
#line 979 "Process.c"
}

static void
optimizer_utils_process_set_mem_usage (OptimizerUtilsProcess* self,
                                       guint64 value)
{
#line 57 "../src/utils/Process.vala"
	g_return_if_fail (self != NULL);
#line 57 "../src/utils/Process.vala"
	self->priv->_mem_usage = value;
#line 990 "Process.c"
}

static void
optimizer_utils_value_process_init (GValue* value)
{
#line 30 "../src/utils/Process.vala"
	value->data[0].v_pointer = NULL;
#line 998 "Process.c"
}

static void
optimizer_utils_value_process_free_value (GValue* value)
{
#line 30 "../src/utils/Process.vala"
	if (value->data[0].v_pointer) {
#line 30 "../src/utils/Process.vala"
		optimizer_utils_process_unref (value->data[0].v_pointer);
#line 1008 "Process.c"
	}
}

static void
optimizer_utils_value_process_copy_value (const GValue* src_value,
                                          GValue* dest_value)
{
#line 30 "../src/utils/Process.vala"
	if (src_value->data[0].v_pointer) {
#line 30 "../src/utils/Process.vala"
		dest_value->data[0].v_pointer = optimizer_utils_process_ref (src_value->data[0].v_pointer);
#line 1020 "Process.c"
	} else {
#line 30 "../src/utils/Process.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1024 "Process.c"
	}
}

static gpointer
optimizer_utils_value_process_peek_pointer (const GValue* value)
{
#line 30 "../src/utils/Process.vala"
	return value->data[0].v_pointer;
#line 1033 "Process.c"
}

static gchar*
optimizer_utils_value_process_collect_value (GValue* value,
                                             guint n_collect_values,
                                             GTypeCValue* collect_values,
                                             guint collect_flags)
{
#line 30 "../src/utils/Process.vala"
	if (collect_values[0].v_pointer) {
#line 1044 "Process.c"
		OptimizerUtilsProcess * object;
		object = collect_values[0].v_pointer;
#line 30 "../src/utils/Process.vala"
		if (object->parent_instance.g_class == NULL) {
#line 30 "../src/utils/Process.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1051 "Process.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 30 "../src/utils/Process.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1055 "Process.c"
		}
#line 30 "../src/utils/Process.vala"
		value->data[0].v_pointer = optimizer_utils_process_ref (object);
#line 1059 "Process.c"
	} else {
#line 30 "../src/utils/Process.vala"
		value->data[0].v_pointer = NULL;
#line 1063 "Process.c"
	}
#line 30 "../src/utils/Process.vala"
	return NULL;
#line 1067 "Process.c"
}

static gchar*
optimizer_utils_value_process_lcopy_value (const GValue* value,
                                           guint n_collect_values,
                                           GTypeCValue* collect_values,
                                           guint collect_flags)
{
	OptimizerUtilsProcess ** object_p;
	object_p = collect_values[0].v_pointer;
#line 30 "../src/utils/Process.vala"
	if (!object_p) {
#line 30 "../src/utils/Process.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1082 "Process.c"
	}
#line 30 "../src/utils/Process.vala"
	if (!value->data[0].v_pointer) {
#line 30 "../src/utils/Process.vala"
		*object_p = NULL;
#line 1088 "Process.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 30 "../src/utils/Process.vala"
		*object_p = value->data[0].v_pointer;
#line 1092 "Process.c"
	} else {
#line 30 "../src/utils/Process.vala"
		*object_p = optimizer_utils_process_ref (value->data[0].v_pointer);
#line 1096 "Process.c"
	}
#line 30 "../src/utils/Process.vala"
	return NULL;
#line 1100 "Process.c"
}

GParamSpec*
optimizer_utils_param_spec_process (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags)
{
	OptimizerUtilsParamSpecProcess* spec;
#line 30 "../src/utils/Process.vala"
	g_return_val_if_fail (g_type_is_a (object_type, OPTIMIZER_UTILS_TYPE_PROCESS), NULL);
#line 30 "../src/utils/Process.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 30 "../src/utils/Process.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 30 "../src/utils/Process.vala"
	return G_PARAM_SPEC (spec);
#line 1119 "Process.c"
}

gpointer
optimizer_utils_value_get_process (const GValue* value)
{
#line 30 "../src/utils/Process.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, OPTIMIZER_UTILS_TYPE_PROCESS), NULL);
#line 30 "../src/utils/Process.vala"
	return value->data[0].v_pointer;
#line 1129 "Process.c"
}

void
optimizer_utils_value_set_process (GValue* value,
                                   gpointer v_object)
{
	OptimizerUtilsProcess * old;
#line 30 "../src/utils/Process.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, OPTIMIZER_UTILS_TYPE_PROCESS));
#line 30 "../src/utils/Process.vala"
	old = value->data[0].v_pointer;
#line 30 "../src/utils/Process.vala"
	if (v_object) {
#line 30 "../src/utils/Process.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, OPTIMIZER_UTILS_TYPE_PROCESS));
#line 30 "../src/utils/Process.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 30 "../src/utils/Process.vala"
		value->data[0].v_pointer = v_object;
#line 30 "../src/utils/Process.vala"
		optimizer_utils_process_ref (value->data[0].v_pointer);
#line 1151 "Process.c"
	} else {
#line 30 "../src/utils/Process.vala"
		value->data[0].v_pointer = NULL;
#line 1155 "Process.c"
	}
#line 30 "../src/utils/Process.vala"
	if (old) {
#line 30 "../src/utils/Process.vala"
		optimizer_utils_process_unref (old);
#line 1161 "Process.c"
	}
}

void
optimizer_utils_value_take_process (GValue* value,
                                    gpointer v_object)
{
	OptimizerUtilsProcess * old;
#line 30 "../src/utils/Process.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, OPTIMIZER_UTILS_TYPE_PROCESS));
#line 30 "../src/utils/Process.vala"
	old = value->data[0].v_pointer;
#line 30 "../src/utils/Process.vala"
	if (v_object) {
#line 30 "../src/utils/Process.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, OPTIMIZER_UTILS_TYPE_PROCESS));
#line 30 "../src/utils/Process.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 30 "../src/utils/Process.vala"
		value->data[0].v_pointer = v_object;
#line 1182 "Process.c"
	} else {
#line 30 "../src/utils/Process.vala"
		value->data[0].v_pointer = NULL;
#line 1186 "Process.c"
	}
#line 30 "../src/utils/Process.vala"
	if (old) {
#line 30 "../src/utils/Process.vala"
		optimizer_utils_process_unref (old);
#line 1192 "Process.c"
	}
}

static void
optimizer_utils_process_class_init (OptimizerUtilsProcessClass * klass,
                                    gpointer klass_data)
{
#line 30 "../src/utils/Process.vala"
	optimizer_utils_process_parent_class = g_type_class_peek_parent (klass);
#line 30 "../src/utils/Process.vala"
	((OptimizerUtilsProcessClass *) klass)->finalize = optimizer_utils_process_finalize;
#line 30 "../src/utils/Process.vala"
	g_type_class_adjust_private_offset (klass, &OptimizerUtilsProcess_private_offset);
#line 1206 "Process.c"
}

static void
optimizer_utils_process_instance_init (OptimizerUtilsProcess * self,
                                       gpointer klass)
{
#line 30 "../src/utils/Process.vala"
	self->priv = optimizer_utils_process_get_instance_private (self);
#line 30 "../src/utils/Process.vala"
	self->ref_count = 1;
#line 1217 "Process.c"
}

static void
optimizer_utils_process_finalize (OptimizerUtilsProcess * obj)
{
	OptimizerUtilsProcess * self;
#line 30 "../src/utils/Process.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, OPTIMIZER_UTILS_TYPE_PROCESS, OptimizerUtilsProcess);
#line 30 "../src/utils/Process.vala"
	g_signal_handlers_destroy (self);
#line 41 "../src/utils/Process.vala"
	_g_free0 (self->priv->_command);
#line 44 "../src/utils/Process.vala"
	_g_free0 (self->priv->_user);
#line 1232 "Process.c"
}

/**
     * The {@code Process} class represents one process
     *
     * @since 1.0.0
     */
static GType
optimizer_utils_process_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { optimizer_utils_value_process_init, optimizer_utils_value_process_free_value, optimizer_utils_value_process_copy_value, optimizer_utils_value_process_peek_pointer, "p", optimizer_utils_value_process_collect_value, "p", optimizer_utils_value_process_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (OptimizerUtilsProcessClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) optimizer_utils_process_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (OptimizerUtilsProcess), 0, (GInstanceInitFunc) optimizer_utils_process_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType optimizer_utils_process_type_id;
	optimizer_utils_process_type_id = g_type_register_fundamental (g_type_fundamental_next (), "OptimizerUtilsProcess", &g_define_type_info, &g_define_type_fundamental_info, 0);
	OptimizerUtilsProcess_private_offset = g_type_add_instance_private (optimizer_utils_process_type_id, sizeof (OptimizerUtilsProcessPrivate));
	return optimizer_utils_process_type_id;
}

GType
optimizer_utils_process_get_type (void)
{
	static volatile gsize optimizer_utils_process_type_id__once = 0;
	if (g_once_init_enter (&optimizer_utils_process_type_id__once)) {
		GType optimizer_utils_process_type_id;
		optimizer_utils_process_type_id = optimizer_utils_process_get_type_once ();
		g_once_init_leave (&optimizer_utils_process_type_id__once, optimizer_utils_process_type_id);
	}
	return optimizer_utils_process_type_id__once;
}

gpointer
optimizer_utils_process_ref (gpointer instance)
{
	OptimizerUtilsProcess * self;
	self = instance;
#line 30 "../src/utils/Process.vala"
	g_atomic_int_inc (&self->ref_count);
#line 30 "../src/utils/Process.vala"
	return instance;
#line 1273 "Process.c"
}

void
optimizer_utils_process_unref (gpointer instance)
{
	OptimizerUtilsProcess * self;
	self = instance;
#line 30 "../src/utils/Process.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 30 "../src/utils/Process.vala"
		OPTIMIZER_UTILS_PROCESS_GET_CLASS (self)->finalize (self);
#line 30 "../src/utils/Process.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1287 "Process.c"
	}
}

